<html>
<head>
<title>DCon 2003 planning with Delphi for .NET and ASP.NET</title>

<%@Import Namespace="Borland.Delphi.Classes"%>
<%@Import Namespace="Borland.Delphi.SysUtils"%>
<%@Import Namespace="Borland.Delphi.IniFiles"%>
<%@Import Namespace="eBob42.Planning"%>

<script language="Delphi" runat="server">

  procedure Page_Load(Sender: System.Object; E: EventArgs);
  const
    Pipe = '&nbsp;&nbsp;&nbsp;'#124'&nbsp;&nbsp;&nbsp;'; 
  var
    Speaker: TStringList;
    Topics,Speakers,i: Integer;
    Topic: String;
  begin
    if not IsPostBack then
    begin
      lbDCon.Text := '<table border=1 cellpadding=3 cellspacing=0><tr bgcolor="ffffaf">' +
        '<th align="center" valign="bottom"><font face="arial" size=2 color=red>' +
        '<a href="http://www.dcon.co.uk/index.htm"target=_DCon>' +
        '<img src="/gif/dc2k1s2.gif" border=0 align=left></a>' +
        Pipe + '<a href="http://www.dcon.co.uk/intro.php"target=_DCon>Overview</a>' + 
        Pipe + '<a href="http://www.dcon.co.uk/sessions.php"target=_DCon>Sessions</a>' +
        Pipe + '<a href="http://www.dcon.co.uk/speakers.php"target=_DCon>Speakers</a>' +
        Pipe + '<a href="http://www.dcon.co.uk/book.php"target=_DCon>Costs &amp; Booking</a>' +
        Pipe + '<a href="http://www.dcon.co.uk/contacts.php"target=_DCon>Contacts</a>' +
        '&nbsp;</th></tr></table>';
      lbError.Text := 'Welcome to the DCon 2003 Session Schedule Planner';
      with TIniFile.Create('F:\Domains\eBob42.com\html\_private\DCon2003.ini') do
      try
        Topics := ReadInteger('topics', 'topics', 0);
        for i:=0 to Pred(Topics) do
        begin
          Topic := ReadString('topics', Format('topic%.d', [i]), '');
          ddlFirst.Items.Add(Topic);
          ddlSecond.Items.Add(Topic)
        end;
        Speakers := ReadInteger('speakers', 'speakers', 0);
        Speaker := TStringList.Create;
        Speaker.Sorted := True;
        for i:=0 to Pred(Speakers) do
          Speaker.Add(ReadString('speakers', Format('speaker%.d', [i]), ''));
        for i:=0 to Pred(Speakers) do
          ddlSpeaker.Items.Add(Speaker[i]);
        Speaker.Free
      finally
        Free // TIniFile
      end
    end
  end;

  procedure btnAgendaClick(Sender: System.Object; E: EventArgs);
  const
    TD = '<td bgcolor="white" align="center"><font face="verdana" size="2"><b>';
  var
    IniFile: TIniFile;
    DCon: TDCon;
    Str: String;
    i,j: Integer;
    Nosel: Boolean;
  
    function TimeAct(const Time,Act: String): String;
    begin 
      Result := Format('<tr><td align="right">' +
        '<font face="verdana" size="2" nowrap>%s</td>' + 
        '<td align="center" colspan="4">' +
        '<font face="verdana" size="2">%s</td></tr>', [Time,Act])
    end;
 
  begin
    lbError.Text := 'Not implemented, yet.';
    try
      IniFile := TIniFile.Create('F:\Domains\eBob42.com\html\_private\DCon2003.ini');
      i := Succ(IniFile.ReadInteger('slots', 'agendax', 0));
      IniFile.WriteInteger('slots', 'agendax', i);
      IniFile.UpdateFile; // just in case...
      try
        DCon := TDCon.Create(IniFile);
        try
          if cbSpeaker.Checked then
            Str := ddlSpeaker.SelectedItem.ToString
          else Str := '';
          lbError.Text := 'Welcome ' + Str;
          DCon.GeneratePlanning(ddlFirst.SelectedIndex, 
                                ddlSecond.SelectedIndex, Str);
          Nosel := False;
          Str := '<table border="1">' +
            '<tr><td colspan="5" bgcolor="darkred" align="center">'+
            '<font face="verdana" size="2" color="white"><b>'+
            'Monday, 9 June 2003</td></tr>' +
            '<tr>' + TD + 'Time</td>' + TD + 'Room</td>' + TD +
            'Session Title</td>' + TD + 'Speaker</td>' + TD + 
            'Level</td></tr>';
          for i:=0 to Pred(DCon.Timeslots) do
          begin
            case i of
              0: Str := Str + '<tr bgcolor="f7e6d5">' +
                   '<td align="right"><font face="verdana" size="2" nowrap>' +
                   '9:00am-9:15am</td>' +
                   '<td align="center"><font face="verdana" size="2">1</td>' +
                   '<td><font face="verdana" size="2"><b>Welcome</td>' +
                   '<td>&nbsp;</td><td>&nbsp;</td></tr>';
              1: Str := Str + TimeAct('10:30am-10:50am', 
                                'Tea/Coffee in the Exhibition area');
              2: Str := Str + TimeAct('12:05pm-1:35pm', 'Lunch');
              3: Str := Str + TimeAct('2:50pm-3:10pm',
                                'Tea/Coffee in the Exhibition area');
              4: Str := Str + TimeAct('4:25pm-4:45pm',
                                'Tea/Coffee in the Exhibition area');
              5: Str := Str + TimeAct('6:00pm-6:15pm', 'Free time');
              6: Str := Str + TimeAct('7:45pm-9:30pm', 'Conference dinner');
              7: Str := Str + '<tr><td colspan="5">&nbsp;</td></tr>' +
                   '<tr><td colspan="5" bgcolor="darkred" align="center">' +
                   '<font face="verdana" size="2" color="white"><b>' +
                   'Tuesday, 10 June 2003</center></td></tr>' +
                   '<tr>' + TD + 'Time</td>' + TD + 'Room</td>' + TD +
                   'Session Title</td>' + TD + 'Speaker</td>' + TD + 
                   'Level</td></tr>';
              8: Str := Str + TimeAct('10:30am-10:50am', 
                                'Tea/Coffee in the Exhibition area');
              9: Str := Str + TimeAct('12:05pm-1:35pm', 'Lunch');
             10: Str := Str + TimeAct('2:50pm-3:10pm',
                                'Tea/Coffee in the Exhibition area');
             11: Str := Str + TimeAct('4:25pm-4:45pm',
                                'Tea/Coffee in the Exhibition area');
            end;
            if Assigned(DCon.Timeslot[i]) then
              if DCon.Timeslot[i].Sessions > 0 then
              begin
                j := DCon.Timeslot[i].Index[0];
                if (i in [0,5]) or 
                   (DCon.Timeslot[i].Session[j].SessionScore > $2) then
                  Str := Str + '<tr bgcolor="f7e6d5">'
                else
                  Str := Str + '<tr bgcolor="d5e6f7">';
                Str := Str + '<td align="right">' +
                  '<font face="verdana" size="2" nowrap>' + 
                  DCon.Timeslot[i].Time + '</td>';
                if (i in [0,5]) or 
                   (DCon.Timeslot[i].Session[j].SessionScore > $2) then
                  Str := Str + '<td align="center">' + 
                    '<font face="verdana" size="2">' + 
                    IntToStr(DCon.Timeslot[i].Session[j].Room) + '</td>'
                else
                begin
                  Nosel := True;
                  Str := Str + '<td align="center" bgcolor="f7e6d5">' + 
                    '<font face="verdana" size="2">' + 
                    IntToStr(DCon.Timeslot[i].Session[j].Room) + '* </td>'
                end;
                Str := Str + Format('<td><font face="verdana" size="2">' +
                  '<b><a href="http://www.dcon.co.uk/talks/sess%.2d.php"' +
                  'target=_DCon>%s</a></td>',
                     [DCon.Timeslot[i].Session[j].ID,
                      DCon.Timeslot[i].Session[j].Title]);
                Str := Str + '<td align="center">'+
                  '<font face="verdana" size="2"><b>' + 
                  DCon.Timeslot[i].Session[j].Speaker + '</td>';
                if i in [0,5] then
                  Str := Str + '<td align="right">' +
                  '<font face="verdana" size="2">All</td>'
                else
                  Str := Str + '<td align="right">' +
                  '<font face="verdana" size="2">' + 
                  DCon.Level[DCon.Timeslot[i].Session[j].Level] + '</td>';
                Str := Str + '</tr>'
              end
          end {for};
          Str := Str + '<tr>' +
            '<td align="right"><font face="verdana" size="2" nowrap>' +
            '6:00pm</td><td align="center" colspan="4">' + 
            '<font face="verdana" size="2">Conference close</td>' +
            '</tr>' +
            '</table>';
          if Nosel then
          begin
            Str := Str + '<p><font size=1>';
            Str := Str + '* Note: in some timeslots, no session selection ' +
              'could be made based on your preferences. In those situations, ';
            Str := Str + '<br>we''ve selected the session in the biggest room,' +
              ' and you should make your own choice from the ' +
              '<a href="http://www.dcon.co.uk/sessions.php"target=_DCon>' +
              'list of sessions</a>.</font>'
          end;
          lbOutput.Text := Str
        finally
          DCon.Free
        end
      finally
        IniFile.Free
      end
    except
      on E: Exception do
        lbError.Text := E.ClassName + ' Error: ' + E.Message
    end
  end;

</script>
</head>

<body bgcolor="#F0F7FF">
<font face="verdana" size="2">
<center>
<asp:label id="lbDCon" runat="server"/>
<form runat="server">
  <table>
  <tr>
    <td><font face="verdana" size="2">First Preference:</td>
    <td><font face="verdana" size="2">Second Preference:</td>
    <td></td>
    <td><font face="verdana" size="2"><asp:checkbox id="cbSpeaker" text="I'm a Speaker" runat="server"/></td>
  </tr><tr>
    <td><asp:dropdownlist id="ddlFirst" runat="server"/></td>
    <td><asp:dropdownlist id="ddlSecond" runat="server"/></td>
    <td><asp:button id="btnAgenda" text="Calculate my Schedule" OnClick="btnAgendaClick" runat="server"/></td>
    <td><asp:dropdownlist id="ddlSpeaker" runat="server">
          <asp:listitem>-- No Speaker --</asp:listitem>
        </asp:dropdownlist></td>
  </tr>
  </table>
  <p>
  <b><asp:label id="lbError" runat="server"/></b>
  <hr>
  <asp:label id="lbOutput" runat="server"/>
</form>
</center>
</body>
</html>